export declare type groupFN = (t: TSTestGroup) => Promise<void>;
export declare type unaryFN = (t: TSUnaryTest) => Promise<void>;
export declare type testFN = (t: TSTest) => Promise<void>;
export declare class TSTester {
    groups: TSTestGroup[];
    desc: string;
    constructor(s: string);
    addGroup(grp: TSTestGroup): void;
    addGroups(grps: TSTestGroup | TSTestGroup[]): void;
    log(format: string, ...args: any[]): void;
    run(): Promise<void>;
}
export declare class TSTest {
    desc: string;
    fn: testFN;
    protected constructor(s: string, f: testFN);
    static group(s: string, f: groupFN): TSTestGroup;
}
export declare class TSTestGroup extends TSTest {
    private _unaries;
    constructor(s: string, f: groupFN);
    unary(s: string, f: unaryFN): void;
    prepare(): Promise<void>;
    log(format: string, ...args: any[]): void;
    run(): Promise<[number, number]>;
}
export declare class TSUnaryTest extends TSTest {
    _group: TSTestGroup;
    private _failed;
    private _passed;
    private _expected;
    private _registrations;
    constructor(g: TSTestGroup, s: string, f: unaryFN);
    log(format: string, ...args: any[]): void;
    run(): Promise<[number, number]>;
    register(name: string, value: any): void;
    printRegistrations(): void;
    expect(v: any, msg?: string): TSExpectAgent;
    expect0(v: any): TSExpectAgent;
    expect1(v: any): TSExpectAgent;
    expect2(v: any): TSExpectAgent;
    expect3(v: any): TSExpectAgent;
    expect4(v: any): TSExpectAgent;
    expect5(v: any): TSExpectAgent;
    expect6(v: any): TSExpectAgent;
    expect7(v: any): TSExpectAgent;
    expect8(v: any): TSExpectAgent;
    expect9(v: any): TSExpectAgent;
    expectA(v: any): TSExpectAgent;
    expectB(v: any): TSExpectAgent;
    expectC(v: any): TSExpectAgent;
    expectD(v: any): TSExpectAgent;
    expectE(v: any): TSExpectAgent;
    expectF(v: any): TSExpectAgent;
    expectG(v: any): TSExpectAgent;
    expectH(v: any): TSExpectAgent;
    expectI(v: any): TSExpectAgent;
    expectJ(v: any): TSExpectAgent;
    expectK(v: any): TSExpectAgent;
    expectL(v: any): TSExpectAgent;
    expectM(v: any): TSExpectAgent;
    expectN(v: any): TSExpectAgent;
    expectO(v: any): TSExpectAgent;
    expectP(v: any): TSExpectAgent;
    expectQ(v: any): TSExpectAgent;
    expectR(v: any): TSExpectAgent;
    expectS(v: any): TSExpectAgent;
    expectT(v: any): TSExpectAgent;
    expectU(v: any): TSExpectAgent;
    expectV(v: any): TSExpectAgent;
    expectW(v: any): TSExpectAgent;
    expectX(v: any): TSExpectAgent;
    expectY(v: any): TSExpectAgent;
    expectZ(v: any): TSExpectAgent;
    fail(): void;
    pass(): void;
}
export declare class TSExpectAgent {
    private _value;
    private _step;
    private _message;
    constructor(step: TSUnaryTest, value: any, msg?: string);
    toBe(aValue: any): void;
    notToBe(aValue: any): void;
    toBeTruthy(): void;
    toBeFalsy(): void;
    toBeUndefined(): void;
    toBeDefined(): void;
    toBeNull(): void;
    toBeNotNull(): void;
    toBeOK(): void;
    toBeNotOK(): void;
    toBeNaN(): void;
    toBeANumber(): void;
    toBeAnInt(): void;
    toBeAnUnsigned(): void;
    toBeAString(): void;
    toBeBool(): void;
    toBeAnEmail(): void;
    toBeAnUrl(): void;
    toBeAnUUID(): void;
    toBeAnObject(): void;
    toBeArray(): void;
    toBeADate(): void;
    toBeAFunction(): void;
    gt(aValue: any): void;
    gte(aValue: any): void;
    lt(aValue: any): void;
    lte(aValue: any): void;
    private _compfail;
    private _elogfail;
    private _nelogfail;
    private _writeMessage;
}
